package com.richard_gauthier.BarreDuHaut 
{
	import com.richard_gauthier.Singleton.MonSingleton;
	import com.richard_gauthier.Texte.Label;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author rg
	 */
	public class BarreDuHaut extends Sprite 
	{
		[Embed (source = "barreMenu.png")]
		private var barreC:Class
		private var barre : Bitmap = new barreC();
		
		[Embed (source = "barreMenuRetour.png")]
		private var barreRetourC:Class
		private var barreRetour : Bitmap = new barreRetourC();
		
		[Embed (source = "/images/etoile1.png")]
		private var etoileC:Class;
		private var monEtoile :Bitmap = new etoileC();
									
		[Embed (source = "transparent.png")]
		private var boutonC:Class
		private var boutonRetour : Sprite = new Sprite();
		private var boutonInit : Sprite = new Sprite();
		private var boutonAide : Sprite = new Sprite();
		
		private var leTexte : Label;
		
		private var singleton : MonSingleton = MonSingleton.getInstance();
				
		public function BarreDuHaut() 
		{
			var largeurEcran : int = singleton.largeurEcran;
			var rapport  : Number = largeurEcran / barre.width;
			barreC = null;
			barre.width = largeurEcran;
			barre.scaleY = rapport;
			addChild(barre);
			
			barreRetourC = null;
			barreRetour.width = largeurEcran;
			barreRetour.scaleY = rapport;
			addChild(barreRetour);
			
			
			boutonRetour.addChild(new boutonC);
			boutonRetour.height = barre.height;
			boutonRetour.width = 80 * rapport;
			boutonRetour.addEventListener(MouseEvent.CLICK, cliqueBouton);
			addChild(boutonRetour);
			
			boutonInit.addChild(new boutonC);
			boutonInit.height = barre.height;
			boutonInit.width = 80 * rapport;
			boutonInit.x = barre.width - boutonInit.width;
			boutonInit.addEventListener(MouseEvent.CLICK, cliqueBouton);
			addChild(boutonInit);
			
			boutonAide.addChild(new boutonC);
			boutonAide.height = barre.height;
			boutonAide.width = barre.width - 2 * boutonInit.width;
			boutonAide.x = boutonInit.width;
			boutonAide.addEventListener(MouseEvent.CLICK, cliqueBouton);
			
			leTexte  = new Label(barre.height/2, 0xffffff);
			leTexte.x = largeurEcran / 2 - leTexte.width / 2 ;
			leTexte.y = barre.height / 2  - leTexte.height / 2;
			addChild(leTexte);
			
			addChild(boutonAide);
			
			var hauteur :int  = barre.height;
			var rapportE :Number  = hauteur * 0.8 / monEtoile.height;
			
			monEtoile.scaleX = rapportE;
			monEtoile.scaleY = rapportE;
			monEtoile.y = hauteur/2 - monEtoile.height/2;
			monEtoile.x = boutonInit.width;
			
			monEtoile.visible = false;
			addChild(monEtoile);
		
			singleton.dispatcherEvenement.add(gestionEventPages);
		
		}
		
		public function barreVisible(numero1:int):void 
		{
			if (numero1 == 1)
			{ barreRetour.visible = true;
			  barre.visible = false;
			} else { barreRetour.visible = false;
			  barre.visible = true;
			}
		}
		
		
		private function cliqueBouton(e:MouseEvent):void 
		{
			switch (e.target) 
			{
				case boutonRetour:
					singleton.dispatcherEvenement.dispatch("boutonRetour");
				break;
				case boutonInit:
					if (barre.visible) singleton.dispatcherEvenement.dispatch("boutonInit");
				break;
			case boutonAide:
				    //trace("hjh");
					if (barre.visible) singleton.dispatcherEvenement.dispatch("boutonAide");
				break;
				default:
			}
		}
		
		public function setText(texteMenu:String):void
		{
			leTexte.setText(texteMenu);
		
		}
		
		private function gestionEventPages(ordreRecus:String):void
		{
			//trace(ordreRecus);
			switch (ordreRecus)
			{
				case "etoileFalse":
					
					monEtoile.visible=false;
					break;
				case "etoileTrue":
					if(!barreRetour.visible) monEtoile.visible=true;
					break;
				
				default: 
			}
		}
		
	}

}