package com.richard_gauthier.CompteurAiguille
{
	import com.richard_gauthier.TexteEnBitmap.TexteEnBitmap;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	/**
	 * ...
	 * @author rg
	 */
	public class CompteurAiguilleVide extends Sprite
	{
		
		private var bar1S:Sprite = new Sprite();
		private var bar2S:Sprite = new Sprite();
		
		private var leTexte:TextField = new TextField();
		public var couleurG:uint = 0xffffff;
		
		private var miniG:Number = 0;
		private var maxiG:Number = 100;
		
		private var transEnbitmap:TexteEnBitmap = new TexteEnBitmap();
		private var monBitmap:Bitmap;
		
		private var diametre : Number=100;
		private var angleDepart : int = 225;
		private var angleInterval : int = 270;
		
		public function CompteurAiguilleVide(leTitre:String = "Le Titre", unite:String = "Unité", mini:Number = 0, maxi:Number = 100, couleur:uint = 0x000000,diametre : Number = 100, angleDepart : int = 225,angleInterval : int = 270,NbEchelle : int = 10)
		{
			if (mini < maxi)
			{
				maxiG = maxi;
				miniG = mini;
			}
			
			couleurG = couleur;
			this.diametre = diametre;
			this.angleDepart = angleDepart;
			this.angleInterval = angleInterval;
			
			var ecart:Number = (maxiG - miniG) / NbEchelle;
			
			var angle:Number;
			var angle1:Number;
			
			for (var i:int = 0; i < NbEchelle+1; i++)
			{
				angle = (angleDepart - i * angleInterval / NbEchelle) * Math.PI / 180;
				angle1 = (-angleInterval/2 + i * angleInterval / NbEchelle);
				label("" + (miniG + ecart * i), diametre * Math.cos(angle) + diametre, -diametre * Math.sin(angle) + diametre, 4, angle1);
			}
			
			//Placer le titre
			label(leTitre, diametre, diametre - 30 , 0);
			
			var formatTexte:TextFormat = new TextFormat();
			formatTexte.font = "tahoma";
			formatTexte.size = 25;
			//formatTexte.bold = true;
			formatTexte.color = couleur;
			formatTexte.align = TextFormatAlign.CENTER;
			
			leTexte.width = 10;
			leTexte.height = 20;
			leTexte.autoSize = TextFieldAutoSize.CENTER;
			leTexte.defaultTextFormat = formatTexte;
			leTexte.text = "1000";
			leTexte.x = diametre  - leTexte.width / 2;
			leTexte.y = diametre+20;
			addChild(leTexte);
			setValue(miniG);
			
			//Placer l'unité
			label(unite, diametre, diametre + 40 + leTexte.height, 6);
			
			
			addChild(bar2S);
		
		}
		
		public function setValue(value:Number):void
		{
			var longueur:Number = diametre - 5;
			leTexte.text = "" + value;
			
			if (value < miniG)
				value = 0;
			else if (value > maxiG)
				value = 268;
			else
			{
				if (miniG >= 0)
					value = angleInterval / (maxiG - miniG) * value;
				else if (miniG < 0)
					value = angleInterval / (maxiG - miniG) * (value - miniG);
				
			}
			
			value = (angleDepart - value) * Math.PI / 180;
			bar2S.graphics.clear();
			bar2S.graphics.lineStyle(5, 0xff0000);
			bar2S.graphics.moveTo(diametre, diametre);
			bar2S.graphics.lineTo(longueur * Math.cos(value) + diametre , -longueur * Math.sin(value) + diametre);
		
		}
		
		private function label(texte:String, posiX:Number, posiY:Number, NbCaracteres:int = -1, angle:Number = 0):void
		{
			if (NbCaracteres > 0)
				if (texte.length > NbCaracteres)
					texte = texte.substr(0, NbCaracteres);
			
			var monSprite:Sprite = new Sprite();
			monBitmap = new Bitmap(transEnbitmap.transformerTexteEnBitmap(texte, couleurG));
			monBitmap.x = -monBitmap.width / 2;
			monBitmap.y = -monBitmap.height;
			
			monSprite.addChild(monBitmap);
			monSprite.x = posiX;
			monSprite.y = posiY;
			//monSprite.graphics.lineStyle(5, 0xff0000);
			//monSprite.graphics.moveTo(0,0);
			//monSprite.graphics.lineTo(0, 20);
			
			monSprite.rotation = angle;
			monBitmap.cacheAsBitmap = true;
			
			addChild(monSprite);
		
			//leTexteMesure.addEventListener(MouseEvent.CLICK,mouseClick)
		
		}
	
	}

}