package com.richard_gauthier.GestionCamera
{
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MediaEvent;
	import flash.media.CameraRoll;
	import flash.media.MediaPromise;
	
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Gestion de la librairie d'images dans le téléphone
	 * permissions à mettre dans application.xml
	 * <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
	 * <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"/>
	 *
	 *
	 */
	public class GestionCameraRoll
	{
		private var singleton:MonSingleton = MonSingleton.getInstance();
		//private var mediaSource: CameraRoll = new CameraRoll();
		private var cr:CameraRoll;
		private var imageBp:Bitmap;
		
		public const EVENEMENT_IMAGE:String = "imageChargerRoll";
		
		public function GestionCameraRoll()
		{
			if (CameraRoll.supportsBrowseForImage)
			{
				
			}
			else
			{
				singleton.dispatcherEvenement.dispatch("erreur", "Camera roll n'est pas supprté.");
			}
		}
		
		public function chargerImage():void
		{
			if (CameraRoll.supportsBrowseForImage)
			{
				cr = new CameraRoll();
				addBrowseListeners();
				cr.browseForImage();
				
					//mediaSource.browseForImage();
			}
		
		}
		
		public function imageCharger():Bitmap
		{
			return imageBp
			imageBp = null;
		}
		
		private var loader:Loader;
		
		private function addBrowseListeners():void
		{
			cr.addEventListener(MediaEvent.SELECT, onImgSelect);
			cr.addEventListener(Event.CANCEL, onCancel);
			cr.addEventListener(ErrorEvent.ERROR, onError);
		}
		
		private function removeBrowseListeners():void
		{
			cr.removeEventListener(MediaEvent.SELECT, onImgSelect);
			cr.removeEventListener(Event.CANCEL, onCancel);
			cr.removeEventListener(ErrorEvent.ERROR, onError);
		}
		
		private function onCancel(event:Event):void
		{
			//infoBox.text="Search canceled";
			removeBrowseListeners();
			//mcPanel.visible=true;
		}
		
		private function onError(event:ErrorEvent):void
		{
			//infoBox.text="Gallery error. You can only load from Gallery.";
			//mcPanel.visible=true;
		}
		
		/*
		   When MediaEvent.SELECT is dispatched, the event's 'data' is an instance of the AS3 class 'MediaPromise'. An instance of MediaPromise can be loaded into our app via Loader.loadFilePromise method.
		 */
		private function onImgSelect(event:MediaEvent):void
		{
			var promise:MediaPromise = event.data as MediaPromise;
			removeBrowseListeners();
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoaded);
			loader.contentLoaderInfo.addEventListener(ErrorEvent.ERROR, onError);
			loader.loadFilePromise(promise);
		}
		
		/*
		   When our loader finished loading the 'file promise', the event Event.COMPLETE is dispatched. We cast the event.currentTarget.content as Bitmap to be able to extract the BitmapData information of the loaded image. Loaded images taken with a phones's camera will, in general, be much larger than the screen. We rescale them using 'ratio'.
		 */
		private function onImageLoaded(event:Event):void
		{
			var bitmapData:BitmapData = Bitmap(event.currentTarget.content).bitmapData;
			imageBp = new Bitmap(bitmapData);
			
			loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onImageLoaded);
			loader.contentLoaderInfo.removeEventListener(ErrorEvent.ERROR, onError);
			singleton.dispatcherEvenement.dispatch(EVENEMENT_IMAGE, "");
			//infoBox.text="";
		}
	
		
	}

}