package com.richard_gauthier.GestionCamera 
{
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MediaEvent;
	import flash.media.CameraRoll;
	import flash.media.MediaPromise;
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Gestion de la librairie d'images dans le téléphone
	 * permissions à mettre dans application.xml
	 * <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
	 * <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"/>
	 *		
	 * 
	 */
	public class GestionCameraRoll 
	{
		private var singleton :MonSingleton = MonSingleton.getInstance();
		private var mediaSource: CameraRoll = new CameraRoll();
        private var imageLoader:Loader; 
		public const  EVENEMENT_IMAGE : String  = "imageChargerRoll";
       		
		public function GestionCameraRoll() 
		{
			if( CameraRoll.supportsBrowseForImage )
                {
                    mediaSource.addEventListener( MediaEvent.SELECT, imageSelected );
                    mediaSource.addEventListener( Event.CANCEL, browseCanceled );
                    
                }
                else
                {
                    singleton.dispatcherEvenement.dispatch("erreur", "Camera roll n'est pas supprté.");
                }
		}
		
		public function chargerImage():void 
		{
			      if( CameraRoll.supportsBrowseForImage )
					mediaSource.browseForImage();
                
        }
            
            private function imageSelected( event:MediaEvent ):void
            {
                var imagePromise:MediaPromise = event.data;
                
                imageLoader = new Loader();
                if( imagePromise.isAsync )
                {
                    log( "Asynchronous media promise." );
                    imageLoader.contentLoaderInfo.addEventListener( Event.COMPLETE, imageLoaded );
                    imageLoader.contentLoaderInfo.addEventListener( IOErrorEvent.IO_ERROR, imageLoadFailed );
                    imageLoader.loadFilePromise( imagePromise );
                }
                else
                {
                    log( "Synchronous media promise." );
                    imageLoader.loadFilePromise( imagePromise );
                    
					 singleton.dispatcherEvenement.dispatch(EVENEMENT_IMAGE,"");
                
					//this.addChild( imageLoader );
                }
            }
            
            private function browseCanceled( event:Event ):void
            {
                log( "Image browse canceled." );
            }
            
            private function imageLoaded( event:Event ):void
            {
                log( "Image loaded asynchronously." );
                singleton.dispatcherEvenement.dispatch(EVENEMENT_IMAGE,"");
				
            }
            
			public function imageCharger():Bitmap
            {
                return imageLoader.content as Bitmap;
				imageLoader = null;
            }
			
            private function imageLoadFailed( event:Event ):void
            {
                log( "Image load failed." );
            }
            
            private function log( text:String ):void
            {
                //trace( text );
            }
		
	}

}