package com.richard_gauthier.GestionCamera 
{
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MediaEvent;
	import flash.media.CameraUI;
	import flash.media.MediaPromise;
	import flash.media.MediaType;
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Gestion de la de la prise de photo dans le téléphone
	 * permissions à mettre dans application.xml
	 * <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
	 * <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"/>
	 *		
	 * 
	 */
	public class GestionCameraUI 
	{
		private var singleton :MonSingleton = MonSingleton.getInstance();
		private var deviceCameraApp:CameraUI = new CameraUI();
        private var imageLoader:Loader; 
		public const  EVENEMENT_IMAGE : String  = "imageChargerUI";
       		
		public function GestionCameraUI() 
		{
			if( CameraUI.isSupported )
               {
                
                deviceCameraApp.addEventListener( MediaEvent.COMPLETE, imageCaptured );
                deviceCameraApp.addEventListener( Event.CANCEL, captureCanceled );
                deviceCameraApp.addEventListener( ErrorEvent.ERROR, cameraError );
               }
               else
               {
                singleton.dispatcherEvenement.dispatch("erreur","La camera n'est pas supportée.");
               }
		}
		
		public function chargerImage():void 
		{
			      if( CameraUI.isSupported )
					deviceCameraApp.launch( MediaType.IMAGE );
                
        }
            
        private function imageCaptured( event:MediaEvent ):void
        {
              
               var imagePromise:MediaPromise = event.data;
       
               if( imagePromise.isAsync )
               {
                //trace( "Asynchronous media promise." );
                imageLoader = new Loader();
                imageLoader.contentLoaderInfo.addEventListener( Event.COMPLETE, asyncImageLoaded );
                imageLoader.addEventListener( IOErrorEvent.IO_ERROR, cameraError );
                
                imageLoader.loadFilePromise( imagePromise );
               }
               else
               {
                //trace( "Synchronous media promise." );
                imageLoader.loadFilePromise( imagePromise );
                singleton.dispatcherEvenement.dispatch(EVENEMENT_IMAGE, "");
			  }
          }
    
          private function captureCanceled( event:Event ):void
          {
               singleton.dispatcherEvenement.dispatch("erreur", "Prise de la photo annulée." );
               //NativeApplication.nativeApplication.exit();
          }
    
          private function asyncImageLoaded( event:Event ):void
          {
             //  trace( "Media loaded in memory." );
              singleton.dispatcherEvenement.dispatch(EVENEMENT_IMAGE, "");
		  }
    
          
      
          private function cameraError( error:ErrorEvent ):void
          {
               singleton.dispatcherEvenement.dispatch("erreur", "Erreur:" + error.text );
               //trace( "Error:" + error.text );
               //NativeApplication.nativeApplication.exit();
          }
			public function imageCharger():Bitmap
            {
                return imageLoader.content as Bitmap;
				imageLoader = null;
            }
			
            
            
            		
	}

}