package com.richard_gauthier.Images
{
	import com.richard_gauthier.Bouton.BoutonCouleur;
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Charge une image JPG avec la fonction load et la dispatche
	 */
	
	public class ImageGesture extends Sprite
	{
		[Embed(source = "fleur.jpg")]
		private var imageC:Class;
		private var imageB:Bitmap = new imageC();
		
		private var image:Sprite = new Sprite();
		
		private var btValiser : BoutonCouleur;
		
		private var singleton : MonSingleton = MonSingleton.getInstance();
		private var largeurEcran:int;
		private var hauteurEcran:int;
		
		private var boiteImage:Sprite = new Sprite();
		
		private var rectBipmapData:BitmapData
		
		private var zoom : Number;
		
		public function ImageGesture()
		{
			largeurEcran = singleton.largeurEcran;
			hauteurEcran = singleton.hauteurEcran;
			
			graphics.beginFill(0xffffff);
			graphics.drawRect( -5, -5, largeurEcran + 10, hauteurEcran + 10);
			
			btValiser = new BoutonCouleur("Valider", largeurEcran,0xffffff,0x000000,20*singleton.rapportX);
			btValiser.addEventListener(MouseEvent.CLICK, boutonCliquer);
			
			
			image.addChild(imageB);
			
			
			singleton.dispatcherEvenement.dispatch("marcheGesture","");
			singleton.dispatcherEvenement.add(gestionEvenement);
			
			
			addChild(image);
			
			var posi : Number = 0.025 * largeurEcran;
			boiteImage.graphics.lineStyle(2 * singleton.rapportX);
			boiteImage.graphics.drawRect(0,0, largeurEcran -2*posi, hauteurEcran - btValiser.height - 2*posi);
			boiteImage.x = posi;
			boiteImage.y = btValiser.height + posi;
			addChild(boiteImage);
			
			image.y = btValiser.height + posi;
			image.x = posi;
			var rapportx : Number = boiteImage.width / image.width;
			var rapporty : Number = boiteImage.height / image.height;
			
			if(rapportx > rapporty) { 
				image.scaleX = rapporty;
				image.scaleY = rapporty;
				zoom = rapporty;
			}
			else { 
				image.scaleX = rapportx;
				image.scaleY = rapportx;
				zoom = rapportx;
			}
			
			image.addEventListener(MouseEvent.MOUSE_DOWN, downMouse);
			image.addEventListener(MouseEvent.MOUSE_UP, upMouse);
			//boiteImage.addEventListener(MouseEvent.MOUSE_OUT, upMouse);
			
			addChild(btValiser);
				
		}
		
		private var monPoint : Sprite = new Sprite();
			
		private  var bit:Bitmap;
		
		private function boutonCliquer(e:MouseEvent):void 
		{
			var posix : int;
			var posiy : int;
			var largeur : int;
			var hauteur : int;
			
			if (image.x < boiteImage.x ) posix = boiteImage.x - image.x;
			else posix = 0;
			if (image.y < boiteImage.y ) posiy = boiteImage.y - image.y;
			else posiy = 0;
			
			if (posix == 0) {
				if (image.width + image.x <= boiteImage.width + boiteImage.x) largeur = image.width;
				else largeur = boiteImage.width - image.x + boiteImage.x;
			
			}
			else largeur = image.width - posix;
			
			if (posiy == 0) {
				if (image.height + image.y <= boiteImage.height + boiteImage.y) hauteur = image.height;
				else hauteur = boiteImage.height - image.y + boiteImage.y;
			
			}
			else hauteur = image.height - posiy;
			
			
			
			monPoint.graphics.clear();
			monPoint.graphics.beginFill(0xff0000);
			monPoint.graphics.drawRect(image.x + posix, image.y + posiy, largeur,hauteur);
			addChild(monPoint);
			
			var monRectangle : Rectangle //= new Rectangle(posix,posiy, largeur,hauteur );
			 monRectangle = boiteImage.getBounds(boiteImage);
			 
			//var bmd:BitmapData = new BitmapData(largeur, hauteur, true, 0);
			var bmd:BitmapData = new BitmapData(image.width, image.height, true, 0);
			//bmd.draw(image);
			
			var m:Matrix = new Matrix();
			//if (posiy > 0 && posix == 0 ) m.translate(0,  posiy);
			//else m.translate(posix, posiy);
		
			//m.translate(posix,posiy);
			//m.tx = posix;
			//m.ty = posiy;
			//trace(posix);
			
			m.scale(zoom,zoom);
			bmd.draw(image, m);
			
			//var alphaOrigin:Point = new Point(0,0);
			//bmd.copyPixels(bmd, monRectangle,alphaOrigin,bmd);

			if (bit != null) removeChild(bit)
			bit = new Bitmap(bmd);
			//addChild(bit);
			image.mask = monPoint;
			//monPoint.visible = false;
			
			//rectBipmapData.copyPixels(Bitmap(image),
		}
		
		private function upMouse(e:MouseEvent):void 
		{
			var ecart : int = 40 * singleton.rapportX;
			image.stopDrag();
			
			
			if (image.x + image.width < boiteImage.x + ecart) image.x = boiteImage.x + ecart - image.width;
			else if (image.x > boiteImage.x + boiteImage.width - ecart ) image.x = boiteImage.x + boiteImage.width - ecart;
		
			if (image.y + image.height < boiteImage.y + ecart) image.y = boiteImage.y + ecart- image.height;
			else if (image.y > boiteImage.y + boiteImage.height - ecart) image.y = boiteImage.y + boiteImage.height - ecart;
			
		
		}
		
		private function downMouse(e:MouseEvent):void 
		{
			image.startDrag();
		}
		
		private function gestionEvenement(evenement:String,valeur:String ):void 
		{
			switch (evenement) 
			{
				case "gestureScale":
					image.scaleX *= Number(valeur); 
					image.scaleY *= Number(valeur); 
				break;
				case "gestureRotation":
					image.rotation *= Number(valeur); 
					
				break;
				default:
			}
		}
		
		
	
	}

}