package com.richard_gauthier.Images
{
	import com.richard_gauthier.barrehaut.BarreHautCouleur2;
	import com.richard_gauthier.Bouton.BoutonCouleur;
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Charge une image JPG avec la fonction load et la dispatche
	 */
	
	public class ImageGesture extends Sprite
	{
		
		public const IMAGE_TRAITER:String = "imageDeGestureTraiter";
		public const ANNULER_IMAGE_TRAITER:String = "AnnulerImageDeGestureTraiter";
		
		//[Embed(source = "fleur.jpg")]
		//private var imageC:Class;
		//private var imageB:Bitmap = new imageC();
		
		private var imageB:Bitmap;
		
		private var image:Sprite = new Sprite();
		
		private var btValiser:BoutonCouleur;
		private var btAnnuler:BoutonCouleur;
		private var btZoomp:BoutonCouleur;
		private var btZoomm:BoutonCouleur;
		private var btRota:BoutonCouleur;
		
		private var barreduHaut:BarreHautCouleur2 = new BarreHautCouleur2("Image", 0xffffff,0x000000, false);
				
		private var singleton:MonSingleton = MonSingleton.getInstance();
		private var largeurEcran:int;
		private var hauteurEcran:int;
		
		private var boiteImage:Sprite = new Sprite();
		
		private var rectBipmapData:BitmapData
		
		private var zoom:Number;
		
		private var angleRota:int = 0;
		private var zoomer:Number = 1;
		
		private var posi:Number;
		
		private var carre1:Sprite;
		private var carre2:Sprite;
		
		private var posiYImage : int;
		
		private var ecarte:int;
		
		public function ImageGesture()
		{
			largeurEcran = singleton.largeurEcran;
			hauteurEcran = singleton.hauteurEcran;
			
			graphics.beginFill(0xcccccc);
			graphics.drawRect(-5, -5, largeurEcran + 10, hauteurEcran + 10);
			
			
			btRota = new BoutonCouleur("Rota", largeurEcran / 3, 0xffffff, 0x000000, singleton.taillePolice * 1.2);
			btRota.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btZoomm = new BoutonCouleur("Zoom-", largeurEcran / 3, 0xffffff, 0x000000, singleton.taillePolice * 1.2);
			btZoomm.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btZoomp = new BoutonCouleur("Zoom+", largeurEcran / 3, 0xffffff, 0x000000, singleton.taillePolice * 1.2);
			btZoomp.addEventListener(MouseEvent.CLICK, boutonCliquer);
			
			//image.addChild(imageB);
			
			
			
			
			singleton.dispatcherEvenement.dispatch("marcheGesture", "");
			singleton.dispatcherEvenement.add(gestionEvenement);
			
			addChild(image);
			
			boiteImage.mouseEnabled = false;
			
			image.addEventListener(MouseEvent.MOUSE_DOWN, downMouse);
			image.addEventListener(MouseEvent.MOUSE_UP, upMouse);
			//image.addEventListener(MouseEvent.MOUSE_OUT, upMouse);
			//boiteImage.addEventListener(MouseEvent.MOUSE_OUT, upMouse);
			
			
			posiYImage = barreduHaut.height;
		
			addChild(barreduHaut);
			
			btValiser = new BoutonCouleur("Valider", 0.3*largeurEcran, 0xffffff, 0xaaaaa, singleton.taillePolice,false);
			btValiser.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btValiser.x = largeurEcran - btValiser.width ;
			btValiser.y = posiYImage / 2 - btValiser.height / 2;
			addChild(btValiser);
			
			
			btAnnuler = new BoutonCouleur("Annuler", 0.3*largeurEcran, 0xffffff, 0xaaaaa, singleton.taillePolice,false);
			btAnnuler.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btAnnuler.y = posiYImage / 2 - btValiser.height / 2;
			addChild(btAnnuler);
			
			var ecart:Number = 0;
			btZoomp.x = ecart;
			btZoomp.y = hauteurEcran - btZoomp.height;
			addChild(btZoomp);
			btZoomm.x = btZoomp.width;
			btZoomm.y = hauteurEcran - btZoomp.height;
			addChild(btZoomm);
			btRota.x = 2 * btZoomp.width;
			btRota.y = hauteurEcran - btZoomp.height;
			addChild(btRota);
			
			ecarte = 10 * singleton.rapportX;
			
			carre1 = creercarre();
			carre2 = creercarre();
			
			addChild(boiteImage);
			
			addChild(carre1);
			
			addChild(carre2);
			carre1.x = carre1.width / 2;
			carre1.y = posiYImage + carre1.width / 2;
			carre2.x = largeurEcran - carre1.width / 2;
			carre2.y = hauteurEcran - btRota.height - carre1.width / 2;
			
			dessinBoiteImage();
			
			carre1.addEventListener(MouseEvent.MOUSE_DOWN, carreDown);
			carre2.addEventListener(MouseEvent.MOUSE_DOWN, carreDown);
			carre1.addEventListener(MouseEvent.MOUSE_MOVE, carreMove);
			carre2.addEventListener(MouseEvent.MOUSE_MOVE, carreMove);
			carre1.addEventListener(MouseEvent.MOUSE_UP, carreUp);
			carre2.addEventListener(MouseEvent.MOUSE_UP, carreUp);
			//carre1.addEventListener(MouseEvent.MOUSE_OVER, carreUp);
			//carre2.addEventListener(MouseEvent.MOUSE_OVER, carreUp);
			
			//chargerImage(new imageC);
			
			positionnerCarre();
		
		}
		
		private function dessinBoiteImage():void
		{
			boiteImage.graphics.clear();
			boiteImage.graphics.lineStyle(4 * singleton.rapportX, 0xffffff);
			boiteImage.graphics.drawRect(0, 0, carre2.x - carre1.x, carre2.y - carre1.y);
			boiteImage.graphics.lineStyle(2 * singleton.rapportX);
			boiteImage.graphics.drawRect(0, 0, carre2.x - carre1.x, carre2.y - carre1.y);
			boiteImage.x = carre1.x;
			boiteImage.y = carre1.y;
		
		}
		
		private function carreMove(e:MouseEvent):void
		{
			dessinBoiteImage();
		}
		
		private function carreDown(e:MouseEvent):void
		{
			setChildIndex(e.target as Sprite, numChildren - 1);
			e.target.startDrag();
			image.mouseEnabled = false;
		}
		
		//********************************************************************************************		
		private function carreUp(e:MouseEvent):void
		{
			e.target.stopDrag();
			dessinBoiteImage();
			image.mouseEnabled = true;
			
			var valeur1:int;
			if (carre1.x > carre2.x)
			{
				valeur1 = carre1.x
				carre1.x = carre2.x;
				carre2.x = valeur1;
			}
			if (carre1.y > carre2.y)
			{
				valeur1 = carre1.y
				carre1.y = carre2.y;
				carre2.y = valeur1;
			}
			
			if (carre1.x < image.x) carre1.x = image.x;
			if (carre1.y < image.y) carre1.y = image.y;
			if (carre2.x > image.x + image.width) carre2.x = image.x + image.width;
			if (carre2.y > image.y + image.height) carre2.y = image.y + image.height;
			
			if (carre1.x < ecarte) positionnerCarre();
			if (carre1.y < ecarte + posiYImage) positionnerCarre();
			if (carre2.x > largeurEcran - ecarte) positionnerCarre();
			if (carre2.y > hauteurEcran - ecarte - posiYImage) positionnerCarre();
			
			dessinBoiteImage();
		
		}
		
		private function creercarre():Sprite
		{
			var carre:Sprite = new Sprite();
			//ecarte = 10;
			
			carre.graphics.lineStyle(2 * singleton.rapportX);
			carre.graphics.beginFill(0xffffff);
			carre.graphics.drawRect(-ecarte, -ecarte, 2 * ecarte, 2 * ecarte);
			return carre;
		
		}
		
		public function chargerImage(display:Bitmap):void
		{
			imageB = display;
			display = null;
			
			image.addChild(imageB);
			
			image.x = ecarte;
			image.y = ecarte + posiYImage;
			var rapportx:Number = (largeurEcran - 2 * ecarte) / image.width;
			var rapporty:Number = (hauteurEcran - 2 * ecarte - 2 * posiYImage) / image.height;
			
			if (rapportx > rapporty)
			{
				zoom = rapporty;
			}
			else
			{
				zoom = rapportx;
			}
			
			imageB.scaleX = zoom;
			imageB.scaleY = zoom;
			
			zoomer = zoom;
			
			positionnerCarre();
		
		}
		
		//private var monPoint:Sprite = new Sprite();
		
		private var bitCouper:Bitmap;
		
		
		private function boutonCliquer(e:MouseEvent):void
		{
			switch (e.target)
			{
			case btAnnuler: 
				image.removeChild(imageB);
				imageB = null;
				//image = null;
				singleton.dispatcherEvenement.dispatch(ANNULER_IMAGE_TRAITER,"");
				break;
			case btValiser: 
				gererBtValider();
				break;
			case btRota: 
				angleRota += 90;
				gererBtRota(angleRota);
				positionnerCarre();
				break;
			case btZoomp: 
				if (zoomer * 1.1 < 3)
				{
					zoomer *= 1.1;
					imageB.scaleX = zoomer;
					imageB.scaleY = zoomer;
					if (angleRota == 90) imageB.x = imageB.width;
					else if (angleRota == 180)
					{
						imageB.x = imageB.width;
						imageB.y = imageB.height;
					}
					else if (angleRota == 270) imageB.y = imageB.height;
					
				}
				
				positionnerCarre();
				break;
			
			case btZoomm: 
				if (zoomer * 0.9 > 0.1)
				{
					zoomer *= 0.9;
					imageB.scaleX = zoomer;
					imageB.scaleY = zoomer;
					if (angleRota == 90) imageB.x = imageB.width;
					else if (angleRota == 180)
					{
						imageB.x = imageB.width;
						imageB.y = imageB.height;
						
					}
					else if (angleRota == 270) imageB.y = imageB.height;
					
				}
				positionnerCarre();
				
				break;
			
			default: 
			}
		
		}
		
		private function positionnerCarre():void
		{
			var valeur1:int;
			if (carre1.x > carre2.x)
			{
				valeur1 = carre1.x
				carre1.x = carre2.x;
				carre2.x = valeur1;
			}
			if (carre1.y > carre2.y)
			{
				valeur1 = carre1.y
				carre1.y = carre2.y;
				carre2.y = valeur1;
			}
			
			if (image.x < ecarte) carre1.x = ecarte;
			else carre1.x = image.x;
			
			if (image.x + image.width > largeurEcran - ecarte) carre2.x = largeurEcran - ecarte;
			else carre2.x = image.x + image.width;
			
			if (image.y < ecarte + posiYImage) carre1.y = ecarte + posiYImage;
			else carre1.y = image.y;
			
			if (image.y + image.height > hauteurEcran - ecarte - posiYImage) carre2.y = hauteurEcran - ecarte - posiYImage;
			else carre2.y = image.y + image.height;
			
			dessinBoiteImage();
		}
		
		private function gererBtRota(angle:int):void
		{
			if (angle == 360)
			{
				angleRota = 0;
				angle = 0;
				
			}
			
			if (angle == 0)
			{
				imageB.x = 0;
				imageB.y = 0;
			}
			else if (angle == 90)
			{
				imageB.x = imageB.height;
				imageB.y = 0;
			}
			else if (angle == 180)
			{
				imageB.x = imageB.height;
				imageB.y = imageB.width;
			}
			else if (angle == 270)
			{
				imageB.x = 0;
				imageB.y = imageB.width;
			}
			
			imageB.rotation = angleRota;
		
		}
		
		private function gererBtValider():void
		{
			var posix:int;
			var posiy:int;
			var largeur:int;
			var hauteur:int;
			
			largeur = boiteImage.width;
			hauteur = boiteImage.height;
			posix = carre1.x - image.x;
			posiy = carre1.y - image.y;
			
			bitCouper = new Bitmap(new BitmapData(largeur, hauteur));
			//bitCouper.bitmapData.draw(image, new Matrix(1, 0, 0, 1, -posix, -posiy), null, null, monRectangle, true);
			bitCouper.bitmapData.draw(image, new Matrix(1, 0, 0, 1, -posix, -posiy));
			//addChild(bitCouper);
			
			//bmd = null;
			image.removeChild(imageB);
			imageB = null;
				
			singleton.dispatcherEvenement.dispatch(IMAGE_TRAITER, "");
		
			//addChild(bit);
			//image.mask = monPoint;
			//monPoint.visible = false;
		
			//rectBipmapData.copyPixels(Bitmap(image),
		}
		
		public function getImage():Bitmap
		{
			
			return bitCouper;
			bitCouper = null;
		
		}
		
		private function upMouse(e:MouseEvent):void
		{
			carre1.mouseEnabled = true;
			carre2.mouseEnabled = true;
			
			var ecart:int = 40 * singleton.rapportX;
			image.stopDrag();
			
			if (image.x + image.width < ecart) image.x = ecart - image.width;
			else if (image.x > largeurEcran - ecart) image.x = largeurEcran - ecart;
			
			if (image.y + image.height < posiYImage + ecart) image.y = posiYImage + ecart - image.height;
			else if (image.y > hauteurEcran - posiYImage - ecart) image.y = hauteurEcran - posiYImage - ecart;
			
			if (carre1.x < image.x)
			{
				if (image.x < ecarte) carre1.x = ecarte;
				else carre1.x = image.x;
			}
			
			if (carre1.y < image.y)
			{
				if (image.y < ecarte) carre1.y = ecarte;
				else carre1.y = image.y;
			}
			
			if (carre2.x > image.x + image.width)
			{
				
				if (image.x + image.width > largeurEcran - ecarte) carre2.x = largeurEcran - ecarte;
				else carre2.x = image.x + image.width;
				
			}
			
			if (carre2.y > image.y + image.height)
			{
				
				if (image.y + image.height > hauteurEcran - ecarte - posiYImage) carre2.y = hauteurEcran - ecarte - posiYImage;
				else carre2.y = image.y + image.height;
				
			}
		
			//positionnerCarre();
			dessinBoiteImage();
		
		}
		
		private function downMouse(e:MouseEvent):void
		{
			carre1.mouseEnabled = false;
			carre2.mouseEnabled = false;
			
			image.startDrag();
		}
		
		private function gestionEvenement(evenement:String, valeur:String):void
		{
			switch (evenement)
			{
			case "gestureScale": 
				image.scaleX *= Number(valeur);
				image.scaleY *= Number(valeur);
				break;
			case "gestureRotation": 
				//image.rotation *= Number(valeur);
				
				break;
			default: 
			}
		}
	
	}

}