package com.richard_gauthier.Images
{
	import com.richard_gauthier.Bouton.BoutonCouleur;
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Charge une image JPG avec la fonction load et la dispatche
	 */
	
	public class ImageGesture extends Sprite
	{
		
		public const IMAGE_TRAITER : String = "imageDeGestureTraiter";
		
		[Embed(source = "fleur.jpg")]
		private var imageC:Class;
		private var imageB:Bitmap = new imageC();
		
		private var image:Sprite = new Sprite();
		
		private var btValiser:BoutonCouleur;
		private var btZoomp:BoutonCouleur;
		private var btZoomm:BoutonCouleur;
		private var btRota:BoutonCouleur;
		
		private var singleton:MonSingleton = MonSingleton.getInstance();
		private var largeurEcran:int;
		private var hauteurEcran:int;
		
		private var boiteImage:Sprite = new Sprite();
		
		private var rectBipmapData:BitmapData
		
		private var zoom:Number;
		
		private var angleRota :int =0;
		private var zoomer :Number =1;
		
		private var posi:Number;
		
		private var carre1:Sprite;
		private var carre2:Sprite;
		
		
		
		
		
		public function ImageGesture()
		{
			largeurEcran = singleton.largeurEcran;
			hauteurEcran = singleton.hauteurEcran;
			
			graphics.beginFill(0xffffff);
			graphics.drawRect(-5, -5, largeurEcran + 10, hauteurEcran + 10);
			
			btValiser = new BoutonCouleur("Valider", largeurEcran, 0xffffff, 0x000000, 20 * singleton.rapportX);
			btValiser.addEventListener(MouseEvent.CLICK, boutonCliquer);
			
			btRota = new BoutonCouleur("Rota", largeurEcran / 3, 0xffffff, 0x000000, 20 * singleton.rapportX);
			btRota.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btZoomm = new BoutonCouleur("Zoom-", largeurEcran / 3, 0xffffff, 0x000000, 20 * singleton.rapportX);
			btZoomm.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btZoomp = new BoutonCouleur("Zoom+", largeurEcran / 3, 0xffffff, 0x000000, 20 * singleton.rapportX);
			btZoomp.addEventListener(MouseEvent.CLICK, boutonCliquer);
			
			//image.addChild(imageB);
			
			singleton.dispatcherEvenement.dispatch("marcheGesture", "");
			singleton.dispatcherEvenement.add(gestionEvenement);
			
			addChild(image);
			
			
			image.addEventListener(MouseEvent.MOUSE_DOWN, downMouse);
			image.addEventListener(MouseEvent.MOUSE_UP, upMouse);
			image.addEventListener(MouseEvent.MOUSE_OVER, upMouse);
			//boiteImage.addEventListener(MouseEvent.MOUSE_OUT, upMouse);
			
			addChild(btValiser);
			var ecart : Number = 0;
			btZoomp.x =  ecart;
			btZoomp.y = hauteurEcran - btZoomp.height;
			addChild(btZoomp);
			btZoomm.x = btZoomp.width;
			btZoomm.y = hauteurEcran - btZoomp.height;
			addChild(btZoomm);
			btRota.x = 2* btZoomp.width;
			btRota.y = hauteurEcran - btZoomp.height;
			addChild(btRota);
			
			carre1 = creercarre();
			carre2 = creercarre();
			
			addChild(boiteImage);
		
			
			
			addChild(carre1);
			
			addChild(carre2);
			carre1.x = carre1.width / 2;
			carre1.y = btValiser.height+carre1.width / 2;
			carre2.x = largeurEcran - carre1.width / 2;
			carre2.y = hauteurEcran - btRota.height - carre1.width / 2;
			
			dessinBoiteImage();
			
			
			carre1.addEventListener(MouseEvent.MOUSE_DOWN, carreDown);
			carre2.addEventListener(MouseEvent.MOUSE_DOWN, carreDown);
			carre1.addEventListener(MouseEvent.MOUSE_MOVE, carreMove);
			carre2.addEventListener(MouseEvent.MOUSE_MOVE, carreMove);
			carre1.addEventListener(MouseEvent.MOUSE_UP , carreUp);
			carre2.addEventListener(MouseEvent.MOUSE_UP , carreUp);
			carre1.addEventListener(MouseEvent.MOUSE_OVER , carreUp);
			carre2.addEventListener(MouseEvent.MOUSE_OVER , carreUp);
			
			
			
			
			
			
			
			
			
			chargerImage(imageB);
			
			
		
		}
		
		private function dessinBoiteImage():void 
		{
			boiteImage.graphics.clear();
			boiteImage.graphics.lineStyle(2 * singleton.rapportX);
			boiteImage.graphics.drawRect(0,0, carre2.x - carre1.x, carre2.y - carre1.y);
			boiteImage.x = carre1.x;
			boiteImage.y = carre1.y;
			
		}
		
		private function carreMove(e:MouseEvent):void 
		{
			dessinBoiteImage();
		}
		
		private function carreDown(e:MouseEvent):void 
		{
			setChildIndex(e.target as Sprite, numChildren - 1);
			e.target.startDrag();
		}
		
		private function carreUp(e:MouseEvent):void 
		{
			e.target.stopDrag();
			dessinBoiteImage();
			
		}
		
		
		
		
		
		private function creercarre():Sprite
		{
		var carre :Sprite = new  Sprite();
		var ecart : int = 10 * singleton.rapportX;
		carre.graphics.lineStyle(2 * singleton.rapportX);
		carre.graphics.beginFill(0xffffff);
		carre.graphics.drawRect( -ecart, -ecart, 2 * ecart, 2 * ecart);
		return carre;
			
		}
		
		
		public function chargerImage(display:Bitmap):void
		{
			image.addChild(display);
			
			image.x = carre1.x;
			image.y = carre1.y;
			var rapportx:Number = boiteImage.width / image.width;
			var rapporty:Number = boiteImage.height / image.height;
			
			if (rapportx > rapporty)
			{
				image.scaleX = rapporty;
				image.scaleY = rapporty;
				zoom = rapporty;
			}
			else
			{
				image.scaleX = rapportx;
				image.scaleY = rapportx;
				zoom = rapportx;
			}
			
			
			
		
		}
		
		
		
		//private var monPoint:Sprite = new Sprite();
		
		private var bitCouper:Bitmap;
		
		private function boutonCliquer(e:MouseEvent):void
		{
			switch (e.target) 
			{
				case btValiser:
					gererBtValider();
				break;
			case btRota:
				angleRota += 90;
					gererBtRota(angleRota);
				break;
			case btZoomp:
					if(zoomer * 1.1 < 3 )
					{
					zoomer *= 1.1;
					imageB.scaleX = zoomer;
					imageB.scaleY = zoomer;
					if(angleRota == 90) imageB.x = imageB.width;
					else if (angleRota == 180) {
						imageB.x = imageB.width;
						imageB.y = imageB.height;
						}
					else if(angleRota == 270) imageB.y = imageB.height;
					
						
					}
					
				break;
			case btZoomm:
					if(zoomer * 0.9 > 0.3 )
					{
					zoomer *= 0.9;
					imageB.scaleX = zoomer;
					imageB.scaleY = zoomer;
					if(angleRota == 90) imageB.x = imageB.width;
					else if (angleRota == 180) {
						imageB.x = imageB.width;
						imageB.y = imageB.height;
						
						}
					else if(angleRota == 270) imageB.y = imageB.height;
					
					
					}
					
				break;
				
				default:
			}
		}
		
		private function gererBtRota(angle:int):void 
		{
			if (angle == 360 ) { angleRota = 0;
			angle = 0;
			
			}
			
			if (angle == 0 ) { imageB.x = 0;
			imageB.y = 0;
			} else if (angle == 90 ) { imageB.x = imageB.height;
			imageB.y = 0;
			}	else if (angle == 180 ) { imageB.x = imageB.height;
			imageB.y = imageB.width;
			}	else if (angle == 270 ) { imageB.x =0;
			imageB.y = imageB.width;
			}
			
			
			imageB.rotation = angleRota;
			
			
		}
			
		private function gererBtValider():void
		{
			var posix:int;
			var posiy:int;
			var largeur:int;
			var hauteur:int;
			/*
			if (image.x < boiteImage.x) posix = boiteImage.x - image.x;
			else posix = 0;
			if (image.y < boiteImage.y) posiy = boiteImage.y - image.y;
			else posiy = 0;
			
			if (posix == 0)
			{
				if (image.width + image.x <= boiteImage.width + boiteImage.x) largeur = image.width;
				else largeur = boiteImage.width - image.x + boiteImage.x;
				
			}
			else largeur = image.width - posix;
			
			if (posiy == 0)
			{
				if (image.height + image.y <= boiteImage.height + boiteImage.y) hauteur = image.height;
				else hauteur = boiteImage.height - image.y + boiteImage.y;
				
			}
			else hauteur = image.height - posiy;
			
			   monPoint.graphics.clear();
			   monPoint.graphics.beginFill(0xff0000);
			   monPoint.graphics.drawRect(image.x + posix, image.y + posiy, largeur, hauteur);
			   addChild(monPoint);
			 */
			
			var monRectangle:Rectangle //= new Rectangle(0,0, largeur,hauteur );
			
			var bmd:BitmapData = new BitmapData(image.width, image.height, true, 0);
			
			var m:Matrix = new Matrix();
			
			m.scale(zoom, zoom);
			bmd.draw(image, m);
			
			//var alphaOrigin:Point = new Point(0,0);
			//bmd.copyPixels(bmd, monRectangle,alphaOrigin,bmd);
			
			//if (bit != null) removeChild(bit)
			//bit = new Bitmap(bmd);
			
			bitCouper = new Bitmap(new BitmapData(largeur, hauteur));
			bitCouper.bitmapData.draw(bmd, new Matrix(1, 0, 0, 1, -posix, -posiy), null, null, monRectangle, true);
			addChild(bitCouper);
			
			bmd = null;
			removeChild(image);
			image = null;
			
		
			singleton.dispatcherEvenement.dispatch(IMAGE_TRAITER, "");
			
			//addChild(bit);
			//image.mask = monPoint;
			//monPoint.visible = false;
			
			
		
			//rectBipmapData.copyPixels(Bitmap(image),
		}
		
		public function getImage():Bitmap
		{
			
			return bitCouper;
			bitCouper = null;
			
		}
		
		private function upMouse(e:MouseEvent):void
		{
			var ecart:int = 40 * singleton.rapportX;
			image.stopDrag();
			
			
			
			if (image.x + image.width < ecart) image.x =  ecart - image.width;
			else if (image.x > largeurEcran - ecart) image.x = largeurEcran  - ecart;
			
			if (image.y + image.height < btValiser.height + ecart) image.y = btValiser.height + ecart - image.height;
			else if (image.y > hauteurEcran -btValiser.height - ecart) image.y = hauteurEcran -btValiser.height - ecart;
		
		
		
		}
		
		private function downMouse(e:MouseEvent):void
		{
			image.startDrag();
		}
		
		private function gestionEvenement(evenement:String, valeur:String):void
		{
			switch (evenement)
			{
			case "gestureScale": 
				image.scaleX *= Number(valeur);
				image.scaleY *= Number(valeur);
				break;
			case "gestureRotation": 
				//image.rotation *= Number(valeur);
				
				break;
			default: 
			}
		}
	
	}

}