package com.richard_gauthier.Texte
{
	import com.richard_gauthier.Bouton.BoutonCouleur;
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	/**
	 * ...
	 * @author rg
	 */
	public class AjoutObjet extends Sprite
	{
		public const AJOUT_TEXTE:String = "Ajoutduntexte";
		public const AJOUT_ANNULE:String = "Ajoutannuler";
		public const AJOUT_PHOTO:String = "Ajoutunephoto";
		public const AJOUT_BIBLIO:String = "Ajoutunbibiblio";
		public const AJOUT_MODIFIER:String = "Ajoutmodifier";
		public const AJOUT_SUPPRIMER:String = "Ajoutsupprimer";
		
		private var largeurEcran:Number;
		private var hauteurEcran:Number;
		
		private var btTexte:BoutonCouleur;
		private var btAnnuler:BoutonCouleur;
		private var btPhoto:BoutonCouleur;
		private var btBiblio:BoutonCouleur;
		private var btModifier:BoutonCouleur;
		private var btSupprimer:BoutonCouleur;
		
		private var singleton:MonSingleton = MonSingleton.getInstance();
		
		public function AjoutObjet()
		{
			
			largeurEcran = singleton.largeurEcran;
			hauteurEcran = singleton.hauteurEcran;
			
			graphics.beginFill(0xaaaaaa, 0.3);
			graphics.drawRect(0, 0, largeurEcran, hauteurEcran);
			
			btTexte = new BoutonCouleur("Ajouter un texte", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btAnnuler = new BoutonCouleur("Annuler", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btPhoto = new BoutonCouleur("Prendre une photo", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btBiblio = new BoutonCouleur("Bibliothèque", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btModifier = new BoutonCouleur("Modifier", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btSupprimer = new BoutonCouleur("Supprimer", 0.9 * largeurEcran, 0xffffff, 0x000000, singleton.taillePolice*1.5);
			btTexte.x = 0.05 * largeurEcran;
			btTexte.y = hauteurEcran - btTexte.height * 6.2;
			addChild(btTexte);
			
			btAnnuler.x = 0.05 * largeurEcran;
			btAnnuler.y = hauteurEcran - btTexte.height * 1.1;
			addChild(btAnnuler);
			
			btBiblio.x = 0.05 * largeurEcran;
			btBiblio.y = hauteurEcran - btTexte.height * 4.2;
			addChild(btBiblio);
			
			btPhoto.x = 0.05 * largeurEcran;
			btPhoto.y = hauteurEcran - btTexte.height * 5.2;
			addChild(btPhoto);
			
			btModifier.x = 0.05 * largeurEcran;
			btModifier.y = hauteurEcran - btTexte.height * 3.2;
			addChild(btModifier);
			
			btSupprimer.x = 0.05 * largeurEcran;
			btSupprimer.y = hauteurEcran - btTexte.height * 2.2;
			addChild(btSupprimer);
			
			
			btAnnuler.valeur = AJOUT_ANNULE;
			btBiblio.valeur = AJOUT_BIBLIO;
			btPhoto.valeur = AJOUT_PHOTO;
			btTexte.valeur = AJOUT_TEXTE;
			btModifier.valeur = AJOUT_MODIFIER;
			btSupprimer.valeur = AJOUT_SUPPRIMER;
			
			btAnnuler.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btBiblio.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btPhoto.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btTexte.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btModifier.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btSupprimer.addEventListener(MouseEvent.CLICK, boutonCliquer);
		
		}
		
		private function boutonCliquer(e:MouseEvent):void
		{
			singleton.dispatcherEvenement.dispatch(e.currentTarget.valeur, "");
		}
	}

}