package com.richard_gauthier.Texte
{
	import com.richard_gauthier.barrehaut.BarreHautCouleur2;
	import com.richard_gauthier.Bouton.BoutonCouleur;
	import com.richard_gauthier.Singleton.MonSingleton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.text.ReturnKeyLabel;
	import flash.text.StageText;
	import flash.text.StageTextInitOptions;
	
	/**
	 * ...
	 * @author Richard GAUTHIER
	 * Charge une image JPG avec la fonction load et la dispatche
	 */
	
	public class GestionStageText extends Sprite
	{
		
		public const VALIDER_STAGE_TEXT:String = "validerGestionStageText";
			public const ANNULER_STAGE_TEXT:String = "annulerGestionStageText";
		
		
		private var btValiser:BoutonCouleur;
		private var btAnnuler:BoutonCouleur;
		//private var btZoomm:BoutonCouleur;
		//private var btRota:BoutonCouleur;
		
		private var barreduHaut:BarreHautCouleur2 = new BarreHautCouleur2("Texte", 0xffffff,0x000000, false);
		
		private var singleton:MonSingleton = MonSingleton.getInstance();
		private var largeurEcran:int;
		private var hauteurEcran:int;
		
		private var ecarte:int;
			
		private	var posiX:int;
		private	var posiY:int;
		private	var largeur : int;
		private	var hauteur:int;
			
		private var stageText:StageText;
		private var stageTextInitOptions:StageTextInitOptions;
		
		private var sceneCreer : Boolean = false;
		private var leTexte:String = "";
	
		
		public function GestionStageText()
		{
			
			
			
			largeurEcran = singleton.largeurEcran;
			hauteurEcran = singleton.hauteurEcran;
			
			graphics.beginFill(0xcccccc);
			graphics.drawRect(-5, -5, largeurEcran + 10, hauteurEcran + 10);
			
			addChild(barreduHaut);
			
			btValiser = new BoutonCouleur("Valider", 0.3*largeurEcran, 0xffffff, 0xaaaaa, singleton.taillePolice,false);
			btValiser.x = largeurEcran - btValiser.width ;
			btValiser.y = barreduHaut.height / 2 - btValiser.height / 2;
			addChild(btValiser);
			
			
			btAnnuler = new BoutonCouleur("Annuler", 0.3*largeurEcran, 0xffffff, 0xaaaaa, singleton.taillePolice,false);
			btAnnuler.y = barreduHaut.height / 2 - btValiser.height / 2;
			addChild(btAnnuler);
			
			btAnnuler.addEventListener(MouseEvent.CLICK, boutonCliquer);
			btValiser.addEventListener(MouseEvent.CLICK, boutonCliquer);
			
			
			ecarte = 10 * singleton.rapportX;
			posiX = 0.05 * largeurEcran;
			posiY = barreduHaut.height + ecarte;
			largeur = largeurEcran * 0.9;
			hauteur = hauteurEcran / 2 - posiY;
			
			graphics.beginFill(0xffffff);
			graphics.drawRect(posiX,posiY, largeur, hauteur);
			
			
			//setText();
			
			addEventListener(Event.ADDED_TO_STAGE, sceneCharger);
			
				
		}
		
		private function sceneCharger(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, sceneCharger);
			
				stageTextInitOptions = new StageTextInitOptions(true);
			
				stageText = new StageText(stageTextInitOptions);
				stageText.autoCorrect = true;
				stageText.fontSize = singleton.taillePolice;
				//stageText.color = 0x000000;
				//stageText.textAlign = "center";
				//stageText.fontWeight = "bold";
				stageText.returnKeyLabel = ReturnKeyLabel.DONE;
				stageText.stage = this.stage;
				
				stageText.viewPort = new Rectangle(posiX, posiY, largeur, hauteur);
				stageText.text = leTexte;
				stageText.assignFocus();
				//stageText.visible = false;
				sceneCreer = true;
		}
		
		
		public function setText(leTexte : String = "Mon texte"):void 
		{	this.leTexte = leTexte
			if (sceneCreer) stageText.text = leTexte;
			
		
		}
		
		
		public function supprimer():void 
		{	stageText.visible = false;
			stageText.dispose();
			stageText = null;
			btAnnuler.removeEventListener(MouseEvent.CLICK, boutonCliquer);
			btValiser.removeEventListener(MouseEvent.CLICK, boutonCliquer);
			
			
			
		
		}
		
		
		
		public function getText():String 
		{	
			return stageText.text;
			
		
		}
		
		
		private function boutonCliquer(e:MouseEvent):void 
		{
				switch (e.currentTarget) 
				{
					case btValiser:
						singleton.dispatcherEvenement.dispatch( VALIDER_STAGE_TEXT, "");
					break;
					case btAnnuler:
						singleton.dispatcherEvenement.dispatch( ANNULER_STAGE_TEXT, "");
					break;
					default:
				}
		}
		
	
	}

}